; include \masm32\MasmBasic\MasmBasic.inc
include \masm32\include\masm32rt.inc
;   .586
;    .model  flat, stdcall
;    option  casemap :none
; 
;    include \masm32\include\windows.inc
;    include \masm32\macros\macros.asm

;    include \masm32\include\kernel32.inc
;    include \masm32\include\user32.inc
;    include \masm32\include\gdi32.inc
;    include \masm32\include\comdlg32.inc            ; printer
    
;----------------------------------------------
;    includelib \masm32\lib\kernel32.lib
;    includelib \masm32\lib\user32.lib
;    includelib \masm32\lib\gdi32.lib
;    includelib \masm32\lib\comdlg32.lib             ; printer
    
; 
WinMain         proto   :DWORD,:DWORD,:DWORD,:DWORD
CmdProc         proto   :DWORD,:DWORD,:DWORD,:DWORD 
WndProcA        proto   :DWORD,:DWORD,:DWORD,:DWORD

GetPrinterDC    proto   :DWORD,:DWORD
TextPrint       proto   :DWORD,:DWORD,:DWORD
CreateFontX     proto   :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

RclRclCpy       proto   :DWORD,:DWORD
RclRclAdd       proto   :DWORD,:DWORD
BarRclAdd       proto   :DWORD
CnvToRcl        proto   :DWORD,:DWORD

MemoAlloc       proto   :DWORD
AllocMemo       proto   :DWORD
; ##############################################################################################
.const
MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN     
MAIN_EXTSTYLE    equ 300h

;----------- Menus ---------------------
IDM_Menu1        equ 1010
IDM_Menu2        equ 1020
IDM_Menu3        equ 1030
IDM_Menu4        equ 1040
;---------------------------------------

$ECRAWIDTH$         equ 1268              ; largura do exr
$ECRAHEIGHT$        equ 966               ; altura do ecr

MAXSIZE             equ 260
;--------------------------------------
;PRINTERLINES        equ 78                      ; number of lines to print/page  VERTI

PRINTERLINESV       equ 78                      ; number of lines to print/page  VERTI
PRINTERLINESH       equ 56                      ; number of lines to print/page  HORIZ

MAXCOLSIZE          equ 117                     ; columns per line
MAXCOLSIZE4         equ 117+4

MaxRegLst           equ 8
LenRegLst           equ 12
EndRegLst           equ 16
CorRegLst           equ 20

FRMPAGES            equ 100                     ; number of pages
FRMLINPAGES         equ 79                      ; lines per page
MAXLINSIZE          equ FRMPAGES * FRMLINPAGES  ; number of lines
;---------------------------------------
; INVALID_SET_FILE_POINTER    equ 0FFFFFFFFh

;.......... To Open File ................
$ArquivoAll     equ FILE_ATTRIBUTE_ARCHIVE or FILE_ATTRIBUTE_READONLY or FILE_ATTRIBUTE_HIDDEN

$ShareFic       equ FILE_SHARE_READ or FILE_SHARE_WRITE 

$AbreOuErro     equ OPEN_EXISTING       ; Se Existe Abre

$ModoAberRd     equ GENERIC_READ        ; Modo de abertura para Leitura
;  Data Section 
.data
_MsgTit1    db 'Erro', 0
_MsgErro    db 'Erro', 0
_MsgErro1   db 'It isnt a text file', 0
_MsgErro2   db 'Choose a file to be printed', 0

_MsgTit2    db 'Teste', 0
_MsgTest    db 'Fonte Seleccionada', 0

_MsgTit3    db 'File Error', 0
_MsgTest3   db 'Erro ao Abrir ou Ler o ficheiro', 0

_MsgTit4    db 'File Error', 0
_MsgErro4   db 'The File is too long', 0

_MsgTit5    db 'Test 5', 0
_MsgTest5   db 'Estou aqui', 0

_MsgTit6    db 'Test 6', 0
_MsgTest6   db 'Estou aqui agora', 0
;----------------------------------------------------
_hpdc        dd 0
_hpFont      dd 0

;---------------------------------------
_FontMSSSerif   db 'MS Sans Serif',0

_DocTitle    db 'Documento',0

_mColumns    dd 120             ;Number of columns  160
_mLines      dd 50              ;Number of lines    84
_WidthCharX  dd ?
_HeightCharY dd ?
;....................................................................................

_MenuName    db 'Menu',0        ; Definido em rsrc.rc
_hWnd        dd 0

;----------------------------------------
_ClassName   db 'WinClass',0
_WindowName  db 'Print Text Files',0
;+++++++++++++++++++++++++++++++++++++++++++++++++++
; see tute_11_3
_OurTitle       db 'Choose the file to open',0

_hFile          dd 0    ; handle
_lFile          dd 0    ; length
_BytesRead      dd 0

_FilterString   db "all Files", 0, "*.*", 0
                db "text Files", 0, "*.txt",0
                db "asm Files", 0, "*.asm",0
                db "bat Files", 0, "*.bat",0                
                db "rc Files", 0, "*.rc",0, 0
                
                ;
                dd MAXSIZE
                dd 0
_FileName       db MAXSIZE dup(0)
                db 0
                ;
                dd 5
                dd 0
_PageNum        db 5 dup (0)
                db 0

                dd 5
_MsgPage        db 'Page '

                ; 
                ; Page X string 
                ; 
                dd 18
                dd 0
_PageBuf        db 18 dup (0)
                db 0
                ;
                dd 5
                dd 0
_NumOfPages     db 5 dup (0)
                db 0
                ;
                dd 1
_SepPage        db '/'
;  Data? Section 
.data?
;---------------------------------------
_hInstance   dd ?
;_hdc         dd ?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>

;dummy1	dd 1000 dup(?)
;_ofn         OPENFILENAME <?>
;dummy2	dd 1000 dup(?)

_lf          LOGFONT <?>
_di          DOCINFO <?>
_pd          PRINTDLG <?>
_tm          TEXTMETRIC  <?>
_rc          RECT <?>
_dm          DEVMODE <>

_PosPrnX     dd ?            ; posio horizontal
_PosPrnY     dd ?            ; posio vertical

_NumPixelX   dd ?
_NumPixelY   dd ?

_LastTxtBuf  dd ?
_PageNumber  dd ?
;-------- For Text buffer -------------
_pTxtMem     dd ?
_pTxtBuf     dd ?
;
_pFrmMem     dd ?
_pFrmBuf     dd ?
;-------------------------------------
_hDevMem        dd ?
_Orientation    dd ?    ; 0=vertical 1=horizontal
_PrinterLines   dd ?
;  Code Section 
.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     _hInstance, eax
    invoke  WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT
; ##############################################################################################
align 16
WinMain     proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC         
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
            invoke  CreateSolidBrush, 0
        	mov   _wcx.hbrBackground, eax          ; COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class
            mov    _wcx.hIcon, NULL                         ;eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx
            ;
            ; Cria a janela
            ; -------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   0, 0, 1280, 990, NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     

            ;invoke    GetPrinterDC, 50, 120

            ; 
            ; Alloc mem for frm buffer
            ; 
            mov     _pFrmMem, 0
            mov     _pFrmBuf, 0
            ;
            mov     eax, MAXCOLSIZE4        ; 120 columns + 1 dword
            mov     ecx, MAXLINSIZE         ; number of lines
            mul     ecx                     ; eax = bytes needed
            add     eax, 24                 ; plus 24 bytes
            invoke  AllocMemo, eax
            jc      short @F
            ;
            mov     _pFrmMem, eax            
            add     eax, 20
            mov     _pFrmBuf, eax
            ;
            mov     dword ptr [eax - MaxRegLst], MAXLINSIZE
            mov     dword ptr [eax - LenRegLst], MAXCOLSIZE4             
            call    IniBufFrm

@@:         invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd
            
;#############################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; 
; process menuitems
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::

;	deb 1, "CmdProc", edx, IDM_Menu1, IDM_Menu2, IDM_Menu3

	     SWITCH  edx

                case    IDM_Menu1       ; Get Printer DC 
                
                    invoke    GetPrinterDC, 50, 120

                case    IDM_Menu2       ; Choose File

                    ; 
                    ; Choose File, Open and Read
                    ; 
                    call    AbreFile

                case    IDM_Menu3       ; Print Text

                    ; 
                    ; Print Text
                    ; 
                    call    PrintText
                    
                case    IDM_Menu4       ; Close
                
                    invoke    SendMessage, _hWnd, WM_CLOSE, 0, 0

                default
                    jmp      _EndProcA
                ENDSW
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp
; ----------------------------------------------------------------------------------------------
SetDevMode      proc
                mov     _hDevMem, 0
                
                mov     eax, sizeof DEVMODE
                invoke  MemoAlloc, eax
                jnc     short @F
                ret
                ;
@@:             mov     _hDevMem, ebx

                ;invoke  GlobalFree, _hDevMem
                 
                ret
SetDevMode      endp
; 
GetOrientation      proc

                    mov         _Orientation, 0              ; assume 0 means vertical
                    mov         _PrinterLines, PRINTERLINESV ; number of lines
                    
                    ; 
                    ; Get the Memory Pointer
                    ; to DEVMODE structure
                    ; 
                    invoke      GlobalLock, _pd.hDevMode           ; ebx=memory handle
                    cmp         eax, NULL
                    jne         short @F

                    fn  MessageBox, _hWnd, "GlobalLock error","Error", MB_OK
                    stc
                    ret
                    
                    ; 
                    ; EAX = starting memory address of DEVMODE structure
                    ;                     
@@:                 mov         ebx, eax
                    mov         eax, [ebx].DEVMODE.dmFields
                    and         eax, DM_ORIENTATION
                    jnz         short @F
                    stc
                    ret

@@:                 mov         ax, [ebx].DEVMODE.dmOrientation
                    cmp         ax, DMORIENT_PORTRAIT
                    jne         short @F
                    
                    fn  MessageBox, _hWnd, "DMORIENT_PORTRAIT","Test", MB_OK
                    clc
                    ret
                    
@@:                 mov     ax, [ebx].DEVMODE.dmOrientation
                    cmp     ax, DMORIENT_LANDSCAPE
                    jne     short @F

                    fn  MessageBox, _hWnd, "DMORIENT_LANDSCAPE","Test", MB_OK

                    mov         _PrinterLines, PRINTERLINESH

                    ;invoke      GlobalUnlock, ebx
                    ;mov         [ebx].DEVMODE.dmOrientation, DMORIENT_PORTRAIT

@@:                 clc         ; assume 0
                    ret
GetOrientation      endp
; 
; Get Printer Device Context to _hpdc
; and create a Font for _mLines=Lin and _mColumns=Col using CreateFontX
; 
GetPrinterDC        proc    Lin:DWORD, Col:DWORD
                    ;
                    mov     eax, Lin
                    add     eax, 4
                    mov     _mLines, eax
                    ;
                    mov     eax, Col
                    mov     _mColumns, eax

                    cmp     _hpdc, 0
                    je      short @F

                    invoke   DeleteObject, _hpFont
                    invoke   DeleteDC, _hpdc
                    mov     _hpdc, 0

                    ; 
                    ; Fill in _pd Structure
                    ; to be used with PrintDlg
                    ; 
@@:                 mov     _pd.lStructSize, sizeof PRINTDLG
                    ;mov     _pd.Flags, PD_RETURNDC or PD_ALLPAGES or PD_HIDEPRINTTOFILE or \
                    ;                   PD_PRINTSETUP
                    mov     _pd.Flags, PD_RETURNDC or PD_PRINTSETUP

                    mov     _pd.nCopies, 1
                    ; 
                    ; This values are valid only if the 
                    ; PD_PAGENUMS flag is specified
                    ; 
                    mov     _pd.nFromPage, 1
                    mov     _pd.nToPage, 1

                    mov     _pd.hDevMode, NULL
                    mov     _pd.hDevNames, NULL

                    mov     _pd.lCustData, NULL
                    mov     _pd.lpfnPrintHook, NULL         ; PD_ENABLEPRINTHOOK
                    mov     _pd.lpfnSetupHook, NULL         ; PD_ENABLESETUPHOOK
                    mov     _pd.lpPrintTemplateName, NULL
                    ;mov     _pd.lpSetupTemplateName, NULL  ; not defined in windows.inc

                    mov     _pd.hPrintTemplate, NULL
                    mov     _pd.hSetupTemplate, NULL
                    
                    ; 
                    ; PD_RETURNDEFAULT
                    ; Causes PrintDlg to return DEVMODE and DEVNAMES structures 
                    ; that are initialized for the system default printer 
                    ; without displaying a dialog box
                    ; 
                    ;mov     _pd.Flags, PD_RETURNDC or PD_RETURNDEFAULT
                    push     _hInstance
                    pop      _pd.hInstance   

                    invoke  PrintDlg, addr _pd
                    cmp     eax, TRUE
                    je      short @F

                    mov     _hpdc, 0
                    ret

@@:                 mov     eax, _pd.hDC
                    mov     _hpdc, eax
                    
                    ; 
                    ; DMORIENT_PORTRAIT or DMORIENT_LANDSCAPE
                    ; 
                    call    GetOrientation
                    ;
                    ; Pixeis na HORIZONTAL
                    ; --------------------
                    ;invoke  GetDeviceCaps, _hpdc, HORZRES
                    ;mov     _NumPixelX, eax
                    ;
                    ; Pixeis na VERICAL
                    ; -----------------
	              ;invoke  GetDeviceCaps, _hpdc, VERTRES
                    ;mov     _NumPixelY, eax
                    ;
                    ; para termos _mColunas ...
                    ; -------------------------
                    ;xor     edx, edx
                    ;mov     eax, _NumPixelX                    
                    ;div     _mColumns
                    ;mov     _WidthCharX, eax
                    ;
                    ; para termos _mLinhas ...
                    ; ------------------------
                    ;xor     edx, edx
                    ;mov     eax, _NumPixelY                                    
                    ;div     _mLines
        	        ;mov     _HeightCharY, eax

                    ; 
                    ; Font
                    ; 
                    ;mov       eax, _WidthCharX
        	        ;mov       edx, _HeightCharY
                    ;neg       edx
                    ;neg       eax
                    ;invoke    CreateFontX, addr _FontMSSSerif, edx, eax, FW_NORMAL, 0
                    ;invoke    CreateFontX, addr _FontMSSSerif, 0, eax, FW_NORMAL, 0
                    invoke    CreateFontX, addr _FontMSSSerif, 0, 0, FW_NORMAL, 0                    
                    jnc       short @F
                    ret
                    ;
@@:                 invoke    SelectObject, _hpdc, _hpFont

                    ;call      SendTeste
                    ret
GetPrinterDC        endp
; ----------------------------------------------------------------------------------------------
CreateFontX     proc    pName:DWORD, Alt:DWORD, Lgr:DWORD, Typ:DWORD, ID:DWORD

                mov     eax, Typ
                mov     _lf.lfWeight, eax
                
                mov     eax, Alt
                mov     _lf.lfHeight, eax
                mov     eax, Lgr       
                mov     _lf.lfWidth, eax
                ;
                mov     _lf.lfEscapement, 0
                mov     _lf.lfOrientation, 0
                mov     _lf.lfItalic, FALSE
                mov     _lf.lfUnderline, FALSE
                mov     _lf.lfStrikeOut, FALSE
                mov     _lf.lfCharSet, ANSI_CHARSET 
                mov     _lf.lfOutPrecision, OUT_DEFAULT_PRECIS or OUT_DEVICE_PRECIS
                mov     _lf.lfClipPrecision, CLIP_DEFAULT_PRECIS
                mov     _lf.lfQuality, PROOF_QUALITY        

                mov     al, DEFAULT_PITCH or FF_MODERN
                mov     edx, ID
                cmp     edx, 0
                je      @F
                             
                mov     al, DEFAULT_PITCH or FF_ROMAN
                cmp     edx, 1
                je      @F

                mov     al, DEFAULT_PITCH or FF_SWISS
                cmp     edx, 2
                je      @F

                mov     al, DEFAULT_PITCH or FF_SCRIPT
                cmp     edx, 3
                je      @F

                mov     al, DEFAULT_PITCH or FF_DECORATIVE
                cmp     edx, 4
                je      @F
                
                mov     al, DEFAULT_PITCH or FF_DONTCARE

@@:             mov     _lf.lfPitchAndFamily, al
                ;
                mov     edx, pName
                mov     ebx, offset _lf
                ;
@@:             movzx   eax, byte ptr [edx]                
                mov     byte ptr [ebx].LOGFONT.lfFaceName, al
                ;
                inc     edx
                inc     ebx
                ;
                or      eax, eax
                jnz     short @B

                invoke  CreateFontIndirect, addr _lf
                mov     _hpFont, eax
                ;
                cmp     eax, 0
                jne     short @F

                call    SendErro
                
                stc
                ret
                
@@:             clc
                ret
CreateFontX     endp
; 
NumOfPages      proc

                mov     ebx, _pFrmBuf
                mov     eax, dword ptr [ebx - EndRegLst]
                mov     ebx, _PrinterLines                  ;PRINTERLINES
                xor     edx, edx
                div     ebx
                or      edx, edx
                jz      short @F
                ;
                add     eax, 1
@@:             invoke  CnvToRcl, eax, addr _NumOfPages
                ret
NumOfPages      endp
; 
; Printing procedures are:
;                           PrintText that calls ...
;                           PrintPage that calls ...
;                           TextPrint that calls TextOut
; 
; Print each line from formated buffer (Frm buffer) pointed by _pFrmBuf 
; There are [ebx - EndRegLst] strings in the buffer pointed by ebx = _pFrmBuf 
;
; 
PrintText           proc     

                    mov     ebx, _pFrmBuf
                    cmp     dword ptr [ebx - EndRegLst], 0
                    jne     short @F

                    invoke  MessageBox, _hWnd, addr _MsgErro2, addr _MsgTit1, MB_OK 
                    ret

                    ; 
                    ; Get Printer DC 50 lines, 120 columns
                    ; 
@@:                 invoke  GetPrinterDC, 50, 120

                    cmp     _hpdc, 0
                    jne     short @F
                    ret
                    
@@:                 mov     _PageNumber, 0
                    call    NumOfPages

                    mov    _di.cbSize, SIZEOF _di
                    mov    _di.lpszDocName, offset _DocTitle
                    mov    _di.lpszOutput, NULL
                    mov    _di.fwType, NULL
                    ;
                    invoke  StartDoc, _hpdc, addr _di
                    cmp     eax, 0
                    jg      short @F
                    ret
                    
@@:                 call    PrintPage
                    jnc     short @B
                                     
                    invoke   DeleteObject, _hpFont
                    invoke   DeleteDC, _hpdc   
                    mov      _hpdc, 0

                    ; 
                    ; Destroy Format Buffer
                    ; 
                    call    IniBufFrm
                    ret
PrintText           endp
; 
PrintPage           proc
                    LOCAL   LinCor:DWORD, MaxLin:DWORD
                    ;
                    invoke  StartPage, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ;
                    invoke  EndDoc, _hpdc
                    stc
                    ret

@@:                 mov     eax, _PrinterLines
                    mov     MaxLin, eax
                    mov     LinCor, 2
                    
                    ; 
                    ; Number of the Page
                    ; 
                    inc     _PageNumber
                    invoke  CnvToRcl, _PageNumber, addr _PageNum

                    invoke  RclRclCpy, addr _MsgPage, addr _PageBuf  
                    invoke  RclRclAdd, addr _PageNum, addr _PageBuf  
                    ;invoke  BarRclAdd, addr _PageBuf
                    invoke  RclRclAdd, addr _SepPage, addr _PageBuf 
                    invoke  RclRclAdd, addr _NumOfPages, addr _PageBuf  

                    cmp     _Orientation, 0
                    je      short @F
                    ;
                    invoke  TextPrint, addr _PageBuf, 1, 95
                    jmp     _start
                    
@@:                 invoke  TextPrint, addr _PageBuf, 1, 84
                    ;...............................................
                    
_start:             call    GetNxtLin
                    jnc     short @F
                    ;
                    ; Fim
                    ;
                    invoke  EndPage, _hpdc
                    invoke  EndDoc, _hpdc                    
                    stc
                    ret
                    ;                     
@@:                 invoke  TextPrint, edi, LinCor, 4
                    ;
                    inc     LinCor
                    ;
                    sub     MaxLin, 1
                    jnz     short _start
                    ;
@@:                 invoke  EndPage, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ;
                    invoke  EndDoc, _hpdc
                    stc
                    ret
                    ;
@@:                 clc
                    ret
PrintPage           endp
; 
; Input:
;       pRcl    - points to a RCL string that have this format:
;
;                           dd ?        <- max length  at  address of _name -8
;                           dd ?        <- length      at  address of _name -4
;                   _Name   db ????????
;
;
TextPrint           proc    pRcl:DWORD, Lin:DWORD, Col:DWORD

                    mov     ebx, pRcl
                    cmp     dword ptr [ebx - 4], 0
                    jne     short @F
                    clc
                    ret
                    
@@:                 invoke  GetTextMetrics, _hpdc, addr _tm
                    ;
                    mov     ecx, _tm.tmHeight
                    mov     eax, Lin
                    sub     eax, 1
                    mul     ecx                 
                    mov     _PosPrnY, eax
                    ;
                    ;
                    ;
                    mov     ecx, _tm.tmAveCharWidth
                    mov     eax, Col
                    sub     eax, 1
                    mul     ecx
                    mov     _PosPrnX, eax

                    invoke  TextOut, _hpdc, _PosPrnX, _PosPrnY, ebx, [ebx - 4]
                    clc
                    ret
TextPrint           endp
; 
;                           END of printing procedures
; 
; 
; Procedures to Get a File, Open, Alloc memory, Read it, format each line, free memory
;            and close file
;
;           AbreFile, FileRead, FormatTxt
;
; 
; Choose a File to open and then Open the file, get the length
; Read it to Text Buffer and format each line to Format Buffer
;
AbreFile        proc uses ebx
LOCAL _ofn:OPENFILENAME
;		deb 1, "Entry", _hFile
                cmp     _hFile, 0
                je      short @F
                ;
                ; Close the previous            
                ; 
                invoke    CloseHandle, _hFile
                mov       _hFile, 0

                ; 
                ; Clean the previous
                ; 
@@:             mov     ebx, offset _FileName
                mov     dword ptr [ebx - 4], 0

                mov     _pTxtMem, 0

                ; 
                ; Get File Name to open
                ; 
                if 1
	mov ecx, SIZEOF _ofn
	xor eax, eax
	push edi
	lea edi, _ofn
;	int 3
	rep stosb
	pop edi
		endif
                mov     _ofn.lStructSize, SIZEOF _ofn
                push    _hWnd
                pop     _ofn.hWndOwner

                push    _hInstance
                pop     _ofn.hInstance
                mov     _ofn.lpstrFilter, OFFSET _FilterString
                mov     _ofn.lpstrFile, OFFSET _FileName
                mov     _ofn.nMaxFile, MAXSIZE
                mov     _ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
                mov     _ofn.lpstrTitle, OFFSET _OurTitle
		mov eax, _ofn.lpstrFilter
		; deb 1, "Before: filter", _hFile, eax$
                invoke  GetOpenFileName, ADDR _ofn
		; deb 1, "After", eax
                
;                stc
;                ret
                
                cmp     eax, TRUE
                je      short @F
                stc
                ret
                ;
@@:             mov     edx, ebx
                ;
_b:             cmp     byte ptr [edx], 0
                je      short @F
                ;             
                inc     dword ptr [ebx - 4]
                add     edx, 1
                jmp     short _b

               
                ; 
                ; Open File
                ; 
@@:

                ; deb 1, "After GetOpenFileName", ebx$

             invoke    CreateFile, ebx, $ModoAberRd, $ShareFic, NULL,
                                           $AbreOuErro, $ArquivoAll, NULL
                ; deb 2, "CreateFile result", eax, ebx$

                cmp       eax, INVALID_HANDLE_VALUE
                je        _erro                                       ; erro
                ;
                ; Save the handle
                ; 
                mov       _hFile, eax
                ;
                ; Get the Length
                ; 
                invoke    GetFileSize, eax, NULL
                ; deb 3, "File size", eax, ebx$

                cmp       eax, INVALID_SET_FILE_POINTER
                jne	  @F
                ;
                ; deb 3, "SendErro3", eax
                call      SendErro3
                ; deb 3, "CloseAll", eax
                call      CloseAll                
                ; deb 3, "CloseAll OK", eax
                stc
                ret

                ; 
                ; _lFile = File Length
                ; 
@@:             mov       _lFile, eax
                add       eax, 10
                ; 
                ; Alloc memory for eax bytes
                ; 
                ; deb 1, "Alloc", eax
                invoke    AllocMemo, eax
                jnc       @F
                ; deb 3, "SendErro3B", eax
                call      SendErro3
                ; deb 3, "CloseAllB", eax
                call      CloseAll
                ; deb 3, "CloseAllB OK", eax
                stc
                ret
                
                ; 
                ;      Read File
                ; 
@@:             mov       _pTxtMem, eax
                add       eax, 8
                mov       _pTxtBuf, eax
                ;
                ; deb 3, "Read", eax
                call      FileRead
                pushfd
                ; deb 3, "Read Ok", eax
		popfd                
                jnc       @F
                ;
                call      CloseAll
                ; deb 3, "CloseAll Ok", eax
                ret

                ; 
                ; Format
                ;       
@@:             call      FormatTxt
		; deb 3, "Format OK", eax, ecx, edx ;, esi$, edi$
                call      CloseAll
                ; deb 3, "CloseAllB Ok", eax
                ret
                ;
_erro:          call      SendErro3
                call      CloseAll
                stc
                ret
AbreFile        endp 
; 
; Input:
;       _hFile  - file handle
;       _lFile  - file length
;
FileRead        proc

                mov     eax, _lFile
                mov     ebx, _pTxtBuf
                
                cmp     eax, dword ptr [ebx - 8]    ; max buffer length
                jbe     short @F

                invoke  MessageBox, _hWnd, addr _MsgErro4, addr _MsgTit4, MB_OK
                ;
                ; File is too long
                ; 
_erro:          mov       dword ptr [ebx - 4], 0      ; buffer length
                call      SendErro3
                stc
                ret
                ;
@@:             invoke    ReadFile, _hFile, ebx, _lFile, addr _BytesRead, NULL
                cmp       eax, 0
                jne	  short @F                 ; leu
                ;
                ; Erro
                ; 
                
                jmp       _erro
;.............................................................................
@@:             mov       eax, _BytesRead
                cmp	  eax, _lFile
                je        short @F
                ;
                call      SendErro3                
                stc
                ret
                ;
@@:             mov     edx, _pTxtBuf           
                mov     dword ptr [edx - 4], eax
                ;
                add     eax, edx
                mov     _LastTxtBuf, eax        ; points to the end address
                                
                clc
                ret
FileRead        endp
; 
; Free memory alloc and close file
;
CloseAll        proc
                pushfd
                ;
                cmp       _pTxtMem, 0
                je        short @F
                ;
                invoke    GlobalFree, _pTxtMem
                mov       _pTxtMem, 0
                ;
@@:             cmp       _hFile, 0
                je        short @F
                
                invoke    CloseHandle, _hFile
                mov       _hFile, 0
   
@@:             popfd
                ret
CloseAll        endp 
; ##############################################################################################
IniBufFrm       proc
                mov     eax, _pFrmBuf                   
                cmp     eax, 0
                jne     short @F
                stc
                ret
                ;
@@:             mov     dword ptr [eax - EndRegLst], 0
                mov     dword ptr [eax - CorRegLst], 0
                clc
                ret
IniBufFrm       endp
; 
; Read Text Buffer and convert each line to Frm buffer
;
FormatTxt       proc
                ;
                call    IniBufFrm
                jnc     short @F
                ret
                ;
@@:             mov     esi, _pTxtBuf                       
                cmp     dword ptr [esi - 4], 0
                jne     short _start
                ret
                ;
                ;
                ;
_cnv:           call    CnvToFrm
                jnc     short _start
                ; 
                ; Insufficient buffer
                ; 
                ret
                ;
                ;
                ;
_start:         call    NxtLinFrm
                jnc     short @F
                ; 
                ; Insufficient buffer
                ;                 
                ret

@@:             call    FindCRLF
                jnc     short _next
                ;
                ; Fim
                ;
                cmp	ecx, _lFile
                je      short @F
                ret
                
                ; 
                ; it isnt a text file
                ; 
@@:             fn  MessageBox, _hWnd, "It isnt a text file", "Error", MB_OK
                ;
                call    IniBufFrm
                stc
                ret
                ;
_next:          cmp     ecx, 0
                je      short _start

                cmp     ecx, MAXCOLSIZE 
                jbe     short _cnv
                ;
                ; Line too long
                ;
                mov     eax, ecx
                sub     eax, MAXCOLSIZE

                push    eax
                    mov     ecx, MAXCOLSIZE                
                    call    CnvToFrm
                pop     ecx
                jnc     short @F

                ; 
                ; Insufficient buffer
                ;                 
                ret
                
@@:             call    NxtLinFrm
                jnc     short _next
                ; 
                ; Insufficient buffer
                ; 
                ret 
FormatTxt       endp
; ----------------------------------------------------------------------------------------------
; Action:
;           Convert Text Buffer string to Format Buffer string
;
; Input:
;           ECX     - line length
;           EBX     - text buffer current position
;           EDI     - frm  buffer initial line position
;
; Output:
;           clc:    OK
;
;           stc:    Insufficient buffer
;
CnvToFrm        proc

                mov     edx, edi
                ;                
_i:             movzx   eax, byte ptr [ebx]
                add     ebx, 1
                
                cmp     al, 09h
                jne     short @F
                
                ; 
                ; Convert this tab to 8 spaces
                ; 
                call    AddSpaces
                jnc     short _n
                ;
                ret
                ;
                ; Next Line
                ;
_erro:          push    eax
                    call    NxtLinFrm
                pop     eax
                jnc     short @F
                ; 
                ; finish
                ; 
                ret
                ;             
@@:             push    eax
                    mov     eax, dword ptr [edi - 4]
                    inc     eax
                    cmp     eax, MAXCOLSIZE 
                pop     eax
                ja _erro

                inc     dword ptr [edi - 4]
                ;
                mov     byte ptr [edx], al
                add     edx, 1
                ;
_n:             sub     ecx, 1
                jnz     short _i

                ; 
                ; End
                ; 
                ret
CnvToFrm        endp
; ----------------------------------------------------------------------------------------------
AddSpaces       proc
                push    ebx
                push    ecx
                ;
                mov     ebx, 8                      ; each TAB = 8 spaces
                mov     ecx, dword ptr [edi - 4]                
                ;
_start:         inc     ecx
                cmp     ecx, MAXCOLSIZE 
                jbe      _next
                ;
                call    NxtLinFrm
                jc      _exit

                mov     edx, edi
                mov     ecx, dword ptr [edi - 4]                
                add     ecx, 1

_next:          mov     dword ptr [edi - 4], ecx
                mov     byte ptr [edx], 20h
                add     edx, 1
                ;
                sub     ebx, 1
                jnz     short _start
                ;
                clc
_exit:          pop     ecx
                pop     ebx
                ret
AddSpaces       endp
; ----------------------------------------------------------------------------------------------
; Input:
;           ESI     - corrente
;
; Output:
;           EBX     - inicial
;           ESI     - prximo
;
;           ECX     - comprimento
;
FindCRLF        proc

                mov     ebx, esi
                xor     ecx, ecx
                jz      short _i
                ;
_n:             add     esi, 1
                cmp     esi, _LastTxtBuf
                jb      short _i
                ;
                mov     ecx, esi
                sub     ecx, ebx
                
                stc
                ret
                ;
_i:             movzx   eax, word ptr [esi]
                ;
                cmp     ax, 0D0Ah
                je      short _e
                
                cmp     ax, 0A0Dh
                jne     short _n
                ;
_e:             mov     ecx, esi
                sub     ecx, ebx
                
                add     esi, 2
                clc                
                ret
FindCRLF        endp
; ----------------------------------------------------------------------------------------------
; Output:
;           clc:    EDI=EDX - points to next line buffer
;       
;
NxtLinFrm       proc

                mov     edi, _pFrmBuf                   
                mov     eax, dword ptr [edi - EndRegLst]
                add     eax, 1
                cmp     eax, dword ptr [edi - MaxRegLst]
                jbe     short @F
                ;
                fn   MessageBox, _hWnd, "Insufficient buffer", "Warning", MB_OK                
                stc
                ret
                ;
@@:             mov     dword ptr [edi - EndRegLst], eax
                ;
                sub     eax, 1
                mul     dword ptr [edi - LenRegLst]
                add     edi, eax
                mov     edx, edi
                ;
                mov     dword ptr [edi - 4], 0              ; string length  = 0
                ;                
                clc
                ret
NxtLinFrm       endp
; ----------------------------------------------------------------------------------------------
; Output:
;           clc:
;                   EDI     - points to current frm line
;
;           stc:    END
;
GetNxtLin       proc

                mov     edi, _pFrmBuf                   
                mov     eax, dword ptr [edi - CorRegLst]
                add     eax, 1
                cmp     eax, dword ptr [edi - EndRegLst]
                jbe     short @F
                ; 
                ; END
                ; 
                stc
                ret
                ;
@@:             mov     dword ptr [edi - CorRegLst], eax
                ;
                sub     eax, 1
                mul     dword ptr [edi - LenRegLst]
                add     edi, eax
                ;                
                clc
                ret
GetNxtLin       endp
; 
; File:     Printer12.inc
; 
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
                ;               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           

                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND
                
                jmp     _EndProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
                ;jmp     _WM_CLOSE
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     cmp     _hpdc, 0
                je      short @F
                ;
                invoke   DeleteDC, _hpdc
                ;
@@:             invoke    GlobalFree, _pFrmMem
                ;
                invoke   DestroyWindow,  hWnd
                jmp     _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                jmp     _ExitProcA 
                
; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam                
                ret
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp
;------------------------------------------------------------------------------------------------------------------****
; Aco:
;           converte a dword Val para DECIMAL e coloca na string RCL apontada
;           por pRcl. Termina a string com 0 e anula a string se o buffer
;           for insuficiente
;
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
CnvToRcl    proc    MyVal:DWORD, pRcl:DWORD
            push    ebx
            push    esi
            push    edi

            mov     eax, [esp+16]           ; Val
            mov     edi, [esp+20]           ; pBuf

            test    eax, eax
            jnz     short @F
            
            mov     dword ptr [edi - 4], 1
            mov     word ptr [edi], 30h
            mov     byte ptr [edi + 1], 0        ; terminate the string
            clc
            jnc     _exit

@@:
            mov     ecx, 3435973837
            xor     esi, esi
                        
@@:             mov     ebx, eax
                mul     ecx
                shr     edx, 3
                mov     eax, edx
                lea     edx, [edx*4+edx]
                add     edx, edx
                sub     ebx, edx
                add     bl, '0'
                ;
                push    ebx                 ; To stack
                add     esi, 1
            or      eax, eax
            jnz     short @B
            
            ; Buffer length control 
            cmp     esi, dword ptr [edi - 8]
            jbe     short _go
            ;
@@:         pop     eax                     ; Get from stack
            sub     esi, 1
            jnz     short @B            
            
            mov     dword ptr [edi - 4], 0
            mov     byte ptr [edi], 0           ; terminate the string            
            stc
            jc      short _exit
            ;
            
_go:        mov     dword ptr [edi - 4], esi
                         
@@:         pop     eax                     ; Get from stack
            mov     byte ptr [edi], al
            add     edi, 1
            sub     esi, 1
            jnz     short @B            

            mov     byte ptr [edi], 0           ; terminate the string
            clc
            
_exit:      pop     edi
            pop     esi
            pop     ebx
            ret     8
CnvToRcl    endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
RclRclCpy       proc    pRcl1:DWORD, pRcl2:DWORD

                mov     ebx, [esp + 4]              ; pRcl1
                mov     ecx, dword ptr [ebx- 4]
                ;
                mov     edx, [esp + 8]              ; pRcl2
                mov     dword ptr [edx - 4], ecx
                
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx] 
                mov     byte ptr [edx + ecx], al
                jnz     short @B
                
                ret     8
RclRclCpy       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
RclRclAdd       proc    pRcl1:DWORD, pRcl2:DWORD

                mov     ebx, [esp + 4]              ; pRcl1
                mov     ecx, dword ptr [ebx - 4]
                ;
                mov     edx, [esp + 8]              ; pRcl2
                mov     eax, dword ptr [edx - 4]                
                add     ecx, eax
                ;
                cmp     ecx, dword ptr [edx - 8]
                jbe     short @F
                ;
                ret     8
                ;             
@@:             mov     dword ptr [edx - 4], ecx
                ;
                add     edx, eax
                mov     ecx, dword ptr [ebx - 4]                
                ;
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx] 
                mov     byte ptr [edx + ecx], al
                jnz     short @B

                ret     8
RclRclAdd       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
; Add Char in AL
;
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
BarRclAdd       proc    pRcl1:DWORD

                mov     edx, [esp + 4]              ; pRcl1
                mov     ecx, dword ptr [edx - 4]                
                add     ecx, 1
                ;
                cmp     ecx, dword ptr [edx - 8]
                jbe     short @F
                ;
                ret     4
                
@@:             mov     dword ptr [edx - 4], ecx
                mov     byte ptr [edx + ecx], "/"

                ret     4
BarRclAdd       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
; Allocate moveable memory
;
; Output:
;           EDI     - ponteiro
;           EBX     - memory handle
;
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
MemoAlloc       proc        Bytes:DWORD
                ;
                mov         eax, [esp + 4]          ; Bytes
                add         eax, 4
                ;
                invoke      GlobalAlloc, GMEM_MOVEABLE, eax
                cmp         eax, NULL
                jne         short @F

                fn  MessageBox, _hWnd, "GlobalAlloc error","Error", MB_OK
                stc
                ret         4
                ;
@@:             mov         ebx, eax                ; ebx = handle
                invoke      GlobalLock, ebx
                cmp         eax, NULL
                jne         short @F

                fn  MessageBox, _hWnd, "GlobalLock error","Error", MB_OK
                stc
                ret         4
                ;
@@:             mov         edi, eax                ; edi - pointer
                invoke      GlobalUnlock, ebx
                cmp         eax, FALSE
                je          short @F
                ;
                ; erro: still locked
                ;
                fn  MessageBox, _hWnd, "GlobalUnlock error","Error", MB_OK
                stc
                ret         4
@@:             call        GetLastError
                cmp         eax, NO_ERROR
                je          short @F
                ;
                ; erro: still locked
                ;
                fn  MessageBox, _hWnd, "GlobalUnlock error stil locked","Error", MB_OK                
                stc    
                ret         4
                ; is unlocked
@@:             clc
                ret         4
MemoAlloc       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
; Output:
;           EAX     - ponteiro
;
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
AllocMemo       proc        Bytes:DWORD        
                ;
                mov         eax, [esp + 4]          ; Bytes
                mov         ebx, eax
                ;
                invoke      GlobalAlloc, GMEM_FIXED, eax
                cmp         eax, NULL
                jne         short @F

                stc
                ret         4
                ;
@@:             sub         ebx, 1
                mov         dword ptr [eax + 0], ebx
                mov         dword ptr [eax + 4], 0
                mov         dword ptr [eax + ebx], 0    ; null terminator               
                clc
                ret         4
AllocMemo       endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; ##############################################################################################
; 
; This procedures are to help me developing the prog...
; 
SendErro        proc
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgErro, addr _MsgTit1, MB_OK 	
                ;
                popad
                ret
SendErro        endp
; 
SendTeste       proc
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest, addr _MsgTit2, MB_OK 	
                ;
                popad
                ret
SendTeste       endp
; 
SendTeste5      proc
                pushfd
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest5, addr _MsgTit5, MB_OK 	
                ;
                popad
                popfd
                ret
SendTeste5      endp
; 
SendTeste6      proc
                pushfd
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest6, addr _MsgTit6, MB_OK 	
                ;
                popad
                popfd
                ret
SendTeste6      endp
; 
SendErro3       proc
                pushad  
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest3, addr _MsgTit3, MB_OK 	
                ;
                popad
                ret
SendErro3       endp                
; 
Test1           proc
pushfd
pushad
fn  MessageBox, _hWnd, "Teste 1","Test1", MB_OK
popad
popfd
ret
Test1           endp
; 
Test2           proc
pushfd
pushad
fn  MessageBox, _hWnd, "Teste 2","Test2", MB_OK
popad
popfd
ret
Test2           endp
; 
Test3           proc
pushfd
pushad
fn  MessageBox, _hWnd, "Teste 3","Test3", MB_OK
popad
popfd
ret
Test3           endp
; 
Test4           proc
pushfd
pushad
fn  MessageBox, _hWnd, "Teste 4","Test4", MB_OK
popad
popfd
ret
Test4           endp
; ##############################################################################################
    end     start

OPT_Res	rsrc	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
OPT_Wait	0
OPT_Tmp2Asm	1
